# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::ApiManagement::Mgmt::V2016_10_10
  module Models
    #
    # Description of an additional API Management resource location.
    #
    class AdditionalRegion

      include MsRestAzure

      # @return [String] The location name of the additional region among Azure
      # Data center regions.
      attr_accessor :location

      # @return [SkuType] The SKU type in the location. Possible values
      # include: 'Developer', 'Standard', 'Premium'
      attr_accessor :sku_type

      # @return [Integer] The SKU Unit count at the location. The maximum SKU
      # Unit count depends on the SkuType. Maximum allowed for Developer SKU is
      # 1, for Standard SKU is 4, and for Premium SKU is 10, at a location.
      # Default value: 1 .
      attr_accessor :sku_unit_count

      # @return [Array<String>] Static IP addresses of the location's virtual
      # machines.
      attr_accessor :static_ips

      # @return [VirtualNetworkConfiguration] Virtual network configuration for
      # the location.
      attr_accessor :vpnconfiguration


      #
      # Mapper for AdditionalRegion class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'AdditionalRegion',
          type: {
            name: 'Composite',
            class_name: 'AdditionalRegion',
            model_properties: {
              location: {
                client_side_validation: true,
                required: true,
                serialized_name: 'location',
                type: {
                  name: 'String'
                }
              },
              sku_type: {
                client_side_validation: true,
                required: true,
                serialized_name: 'skuType',
                type: {
                  name: 'Enum',
                  module: 'SkuType'
                }
              },
              sku_unit_count: {
                client_side_validation: true,
                required: false,
                serialized_name: 'skuUnitCount',
                default_value: 1,
                constraints: {
                  InclusiveMaximum: 10
                },
                type: {
                  name: 'Number'
                }
              },
              static_ips: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'staticIPs',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'StringElementType',
                      type: {
                        name: 'String'
                      }
                  }
                }
              },
              vpnconfiguration: {
                client_side_validation: true,
                required: false,
                serialized_name: 'vpnconfiguration',
                type: {
                  name: 'Composite',
                  class_name: 'VirtualNetworkConfiguration'
                }
              }
            }
          }
        }
      end
    end
  end
end
